#set difficulty to 1 if no other difficulty was previously set
execute unless score #uc.data.difficulty uc.score.difficulty matches 1..4 run scoreboard players set #uc.data.difficulty uc.score.difficulty 1

#detecting game progression to increase difficulty
execute if score #uc.data.difficulty uc.score.difficulty matches 1 run function ultracore:gameplay/progression_detection_1
execute if score #uc.data.difficulty uc.score.difficulty matches 2 run function ultracore:gameplay/progression_detection_2
execute if score #uc.data.difficulty uc.score.difficulty matches 3 run function ultracore:gameplay/progression_detection_3

#running the mob managers based on difficulty
execute if score #uc.data.difficulty uc.score.difficulty matches 1 as @e[type=#ultracore:ultracore_mobs,tag=!uc.tag.checked] run function ultracore:mobs/spawn_modifications_lvl1
execute if score #uc.data.difficulty uc.score.difficulty matches 2 run function ultracore:mobs/level_2
execute if score #uc.data.difficulty uc.score.difficulty matches 3 run function ultracore:mobs/level_3
execute if score #uc.data.difficulty uc.score.difficulty matches 4 run function ultracore:mobs/level_4

#run the managers
function ultracore:environments/environment_manager
function ultracore:events/event_manager
execute as @e[type=item,nbt={Item: {id: "minecraft:amethyst_shard", Count: 1b}}] run function ultracore:revival/revival_manager
execute as @e[type=item,nbt={Item: {id: "minecraft:blaze_rod", Count: 2b}}] run function ultracore:sun_summoning/sun_manager
execute as @e[type=boat,nbt={Passengers:[{id:"minecraft:enderman"}]}] run function ultracore:mobs/kill_enderman_boat
execute if score #uc.data.difficulty uc.score.difficulty matches 2.. run function ultracore:gameplay/no_regen

#data modification for slimes and zombies
data modify entity @e[tag=uc.tag.boss,limit=1,sort=random,type=zombie] DrownedConversionTime set value -1
data remove entity @e[type=slime,nbt=!{Size:10},limit=1] DeathLootTable

#dead people
execute as @a[scores={uc.score.deaths=1..}] run function ultracore:gameplay/dead

#reset clock
scoreboard players set @a[scores={uc.score.clock=20..}] uc.score.clock 0
